// worker0.cpp -- Metody klas hierarchii
#include "worker0.h"
#include <iostream>
using std::cout;
using std::cin;
using std::endl;
// Metody klasy Worker

// Potrzebna implementacja destruktora wirtualnego, nawet jeli jest on czysto wirtualny
Worker::~Worker() {}

void Worker::Set()
{
   cout << "Podaj imi i nazwisko pracownika: ";
   std::getline(cin, fullname);
   cout << "Podaj numer identyfikacyjny pracownika: ";
   cin >> id;
   while (cin.get() != '\n')
      continue;
}

void Worker::Show() const
{
   cout << "Imi i nazwisko: " << fullname << "\n";
   cout << "Numer identyfikacyjny: " << id << "\n";
}

// Metody klasy Waiter
void Waiter::Set()
{
   Worker::Set();
   cout << "Podaj poziom elegancji kelnera: ";
   cin >> panache;
   while (cin.get() != '\n')
      continue;
}

void Waiter::Show() const
{
   cout << "Kategoria: kelner\n";
   Worker::Show();
   cout << "Elegancja: " << panache << "\n";
}

// Metody klasy Singer
char * Singer::pv[] = {"inny", "alt", "kontralt", "sopran",
                       "bas", "baryton", "tenor"};

void Singer::Set()
{
   Worker::Set();
   cout << "Podaj numer skali gosu piosenkarza:\n";
   int i;
   for (i = 0; i < Vtypes; i++)
   {
      cout << i << ": " << pv[i] << "   ";
      if (i % 4 == 3)
         cout << endl;
   }
   if (i % 4 != 0)
      cout << endl;
   cin >> voice;
   while (cin.get() != '\n')
      continue;
}

void Singer::Show() const
{
   cout << "Kategoria: piosenkarz\n";
   Worker::Show();
   cout << "Skala gosu: " << pv[voice] << endl;
}

